/********************************** (C) COPYRIGHT *******************************
* File Name          : CH392UART.C
* Author             : WCH
* Version            : V1.0
* Date               : 2020/02/19
* Description        : CH392оƬ UARTӵӲ V1.0
*                      
*******************************************************************************/
#include "sys.h"

#define UART_INIT_BAUDRATE         9600            /* ĬͨѶ9600bps,ͨӲ趨ֱѡߵCH395ĬͨѶ */

/*******************************************************************************
 * Function Name  : CH392_Port_Init
 * Description    : ʼCH392ӿ
 * Input          : None                                 
 * Return         : None
 *******************************************************************************/
void CH392_Port_Init(void)
{  
	GPIO_InitTypeDef  GPIO_InitStructure;
	USART_InitTypeDef USART_InitStructure;

	RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2, ENABLE);	
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA , ENABLE);		
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2; 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;	
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	GPIO_Init(GPIOA, &GPIO_InitStructure);	

	USART_InitStructure.USART_BaudRate = UART_INIT_BAUDRATE;
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	USART_InitStructure.USART_Parity = USART_Parity_No;
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;

	USART_Init(USART2, &USART_InitStructure); 
	USART_Cmd(USART2, ENABLE);  
}

/*******************************************************************************
 * Function Name  : USART2_SendByte
 * Description    : ڷһֽ  
 * Input          : u8 Data                               
 * Return         : None
 *******************************************************************************/
void USART2_SendByte(u8 Data)
{
	USART_SendData(USART2, Data);
	while(USART_GetFlagStatus(USART2, USART_FLAG_TXE) == RESET)
	{
	}
}

/*******************************************************************************
 * Function Name  : USART2_RcvByte
 * Description    : ڽһֽ   
 * Input          : None                                 
 * Return         : None
 *******************************************************************************/
u8 USART2_RcvByte(void)
{
	u8 i;
	while(USART_GetFlagStatus(USART2, USART_FLAG_RXNE) == RESET)
	{ 
	}
	i=USART_ReceiveData(USART2);
	return i;
}

/********************************************************************************
* Function Name  : xWriteCH392Cmd
* Description    : CH392д
* Input          : cmd 8λ
* Output         : None
* Return         : None
*******************************************************************************/
void xWriteCH392Cmd(u8 cmd)                                      
{
	USART2_SendByte(SER_SYNC_CODE1);  /* ĵ1ͬ */
	USART2_SendByte(SER_SYNC_CODE2);  /* ĵ2ͬ */
	USART2_SendByte(cmd);             /*  */  
}

/********************************************************************************
* Function Name  : xWriteCH392Data
* Description    : CH392д
* Input          : mdata 8λ
* Output         : None
* Return         : None
*******************************************************************************/
void  xWriteCH392Data(u8 mdata)
{                                                                    /* CH392д */
	USART2_SendByte(mdata);                                             /*  */                                                                
}

/********************************************************************************
* Function Name  : xReadCH392Data
* Description    : CH392
* Input          : None
* Output         : None
* Return         : 8λ
*******************************************************************************/
u8  xReadCH392Data(void)                                          /* CH392 */
{
	u8 i;
	i=USART2_RcvByte();    
	return i;
}

#define xEndCH392Cmd()     {}                                        /* SPIģʽЧ */


