/********************************** (C) COPYRIGHT *********************************
* File Name          : CH392.H
* Author             : WCH
* Version            : V1.0
* Date               : 2020/02/19
* Description        : CH392ṹ˵                  
**********************************************************************************/
#ifndef __CH392_H__
#define __CH392_H__

#include "stdio.h"
#include "string.h"
#include "CH392INC.H"
#include "CH392CMD.H"

#define TCP_CLIENT_MODE                                      0
#define TCP_SERVER_MODE                                      1

struct _CH392_SYS
{
    UINT8   IPAddr[4];                                           /* CH392IPַ 32bit*/
    UINT8   GWIPAddr[4];                                         /* CH392صַ 32bit*/
    UINT8   MASKAddr[4];                                         /* CH392 32bit*/
    UINT8   MacAddr[6];                                          /* CH392MACַ 48bit*/
    UINT8   PHYStat;                                             /* CH392 PHY״̬ 8bit*/
    UINT8   MackFilt;                                            /* CH392 MACˣĬΪչ㲥ձMAC 8bit*/
    UINT32  RetranCount;                                         /* Դ ĬΪ10*/
    UINT32  RetranPeriod;                                        /* ,λMS,Ĭ200MS */
    UINT8   IntfMode;                                            /* ӿģʽ */
    UINT8   UnreachIPAddr[4];                                    /* ɵIP */
    UINT16  UnreachPort;                                         /* ɵ˿ */
};

struct _SOCK_INF
{
    UINT8  IPAddr[4];                                           /* socketĿIPַ 32bit*/
    UINT8  MacAddr[6];                                          /* socketĿַ 48bit*/
    UINT8  ProtoType;                                           /* Э */
    UINT8  ScokStatus;                                          /* socket״̬οscoket״̬ */
    UINT8  TcpMode;                                             /* TCPģʽ */
    UINT32 IPRAWProtoType;                                      /* IPRAW Э */
    UINT16 DesPort;                                             /* ĿĶ˿ */
    UINT16 SourPort;                                            /* Դ˿ */
    UINT16 SendLen;                                             /* ݳ */
    UINT16 RemLen;                                              /* ʣ೤ */
    UINT8  *pSend;                                              /* ָ */                                               
};    

void mStopIfError(UINT8 iError);
void InitCH392InfParam(void);
void InitSocket0Param(void);
void CH392Socket0InitOpen(void);
void keeplive_set(void);
void CH392SocketInterrupt(UINT8 sockindex);
void CH392GlobalInterrupt(void);
UINT8  CH392Init(void);
void InitSocket1Param(void);
void CH392Socket1InitOpen(void);

#endif


